/*
    setwindrv TiMidity++ config file ediotr.
    Copyright (C) 2006-2007 Keishi Suenaga <skeishi@yahoo.co.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif


#ifdef WIN32
#ifdef _MSC_VER
#define _CRT_SECURE_NO_DEPRECATE
#endif 
#include <windows.h>
#define strcasecmp _stricmp
#endif

#include <stdio.h>
#include <gtk/gtk.h>

#include <string.h>
#include <ctype.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "file_io.h"

GtkWidget *windrv_setup;

GtkWidget *entry1;
GtkWidget *entry2;
GtkWidget *output_device_lbl;
GtkWidget *comboboxentry1;

GtkWidget *out_winmm_btn;
GtkWidget *out_pa_win_btn;
GtkWidget *out_pa_directx_btn;
GtkWidget *out_pa_asio_btn;


GtkWidget *textview4, *textview3, *textview2, *textview5 ;
GtkTextTagTable *dir_table, *sf2_sel_table, *sf2_table, *cfg_table,
                *other_table, *other_syntax_table,*comment_table, *extension_table;
GtkTextBuffer *dir_buffer, *sf2_sel_buffer, *sf2_buffer, *cfg_buffer,
              *other_buffer, *other_syntax_buffer, *comment_buffer, *extension_buffer;
//GtkTextIter dir_iter, sf2_sel_iter, sf2_iter, cfg_iter;
//gint dir_cline, sf2_sel_cline, sf2_cline, cfg_cline;

GtkWidget *cfg_edit_dlg;
GtkWidget *dir_select_dlg;
GtkWidget *about_win_dlg;
GtkWidget *cfg_open_dlg;
GtkWidget *options_dlg;

GtkWidget *cfg_editor_ent;
GtkWidget *sf2_editor_ent;

#define DROP_TEXT_URI_LIST  10
#define DROP_TEXT_X_MOZ_URL 20
#define DROP_NETSCAPE_URL   30
#define DROP_TEXT_HTML      40
#define DROP_TEXT_PLAIN     50

static GtkTargetEntry drop_targets[] = {
  /*
  { "STRING", GTK_TARGET_SAME_APP, 0 },
  { "BINARY", GTK_TARGET_SAME_WIDGET, 0 },
  */
  { "text/uri-list",  0, DROP_TEXT_URI_LIST },
  { "text/x-moz-url", 0, DROP_TEXT_X_MOZ_URL },
  { "_NETSCAPE_URL_", 0, DROP_NETSCAPE_URL },
  { "text/html",      0, DROP_TEXT_HTML },
  { "text/plain",     0, DROP_TEXT_PLAIN }
};

gdouble latency= -1;
gchar out_device_c='d';
gchar output_format[256]={0};
char device_list[DEVICE_LIST_MAX][MAX_LINE];
gint deviceID = -1;
gint devID[DEVICE_LIST_MAX];
gint devIDn = 0;
gchar cfg_editor_path[256];
gchar sf2_editor_path[256];
gchar cfg_editor_path_buf[256];
gchar sf2_editor_path_buf[256];
GKeyFile* inifile;
#define INIFILE_NAME "setwindrv.ini"
gchar inifile_name[256];
gchar open_browser[256];

#define my_iter_line_star(a)  gtk_text_iter_backward_chars((a),gtk_text_iter_get_line_offset (a))
void rm_cr_buffer(GtkTextBuffer *buffer);
void add_cr_buffer(GtkTextBuffer *buffer);
void rm_cr_buffers();
void add_cr_buffers();
gint get_cur_line_buffer(GtkTextBuffer *buffer);
void highlight_range_buffer(GtkTextBuffer *buffer, GtkTextIter *sl_iter, GtkTextIter *el_iter);
void highlight_line_buffer(GtkTextBuffer *buffer, int linen);
void highlight_cur_line_buffer(GtkTextBuffer *buffer);
void highlight_end_line_buffer(GtkTextBuffer *buffer);
void set_device_list(void);
//void cr_add_buffer(GtkTextBuffer *buffer);
void cr_rm_buffer(GtkTextBuffer *buffer);
gchar *getline_buffer(GtkTextBuffer *buffer, gint line_number);
gint search_buffer(const GtkTextBuffer *buffer, const char *key, gboolean forward);
gint case_search_buffer(const GtkTextBuffer *buffer, const char *key, gboolean forward);
gboolean get_sel_num_buffer(GtkTextBuffer *buffer, gint *start, gint *end);
void update_sf2_sel_buffer(void);
void clear_buffer(GtkTextBuffer *buffer);
void update_cfg_buffer(void);
gint saveconfig_buffer(void);
void rmstr_string(gchar *str, gchar *key);
void update_out_buttons(void);
void set_deviceID(int deviceID);
void reduce_space(char *buf);
void rm_comment(char *buf);
void parse_one_line(char *buf);
void apply_config_buffer(void);
gint readconfig_buffer(void);
void dir_add(const gchar *dir_path);
void sf2_add(const gchar *sf2_name);
gboolean find_full_acp_path(gchar *path);
void show_syntax(GtkTextBuffer *buffer, gint line);
void next_action(GtkTextBuffer *buffer, gint line);
void inifile_read(void);
void inifile_write(void);
void get_open_browser(void);

void rm_cr_buffer(GtkTextBuffer *buffer)
{

  gint linen,offset;
  GtkTextIter s_iter, e_iter;
  gtk_text_buffer_get_end_iter(buffer,&s_iter);
  e_iter=s_iter;
  offset=gtk_text_iter_get_offset(&e_iter);
  gtk_text_iter_set_offset (&e_iter, offset-1);
  gtk_text_buffer_delete(GTK_TEXT_BUFFER(buffer),&s_iter,&e_iter);

}
void add_cr_buffer(GtkTextBuffer *buffer)
{
  GtkTextIter e_iter, iter;
  int offset;

  gtk_text_buffer_get_end_iter(buffer,&e_iter);
  iter=e_iter;
  offset=gtk_text_iter_get_offset(&iter);
  gtk_text_iter_set_offset (&iter, offset-1);
  if(gtk_text_iter_is_start(&iter) == TRUE) return;
  gtk_text_buffer_insert(buffer,&e_iter,"\n",1);
}
void add_cr_buffers()
{
  add_cr_buffer(dir_buffer);
  add_cr_buffer(sf2_sel_buffer);
  add_cr_buffer(sf2_buffer);

}
void rm_cr_buffers()
{
  rm_cr_buffer(dir_buffer);
  rm_cr_buffer(sf2_sel_buffer);
  rm_cr_buffer(sf2_buffer);
  gtk_text_buffer_set_modified (dir_buffer, FALSE);
  gtk_text_buffer_set_modified (sf2_sel_buffer, FALSE);
  gtk_text_buffer_set_modified (sf2_buffer, FALSE);

}

gint get_cur_line_buffer(GtkTextBuffer *buffer)
{
  GtkTextIter iter;
  gint line;

  gtk_text_buffer_get_iter_at_mark(buffer,&iter, gtk_text_buffer_get_insert(buffer));
  return  gtk_text_iter_get_line(&iter);
}
  
void highlight_range_buffer(GtkTextBuffer *buffer, GtkTextIter *sl_iter, GtkTextIter *el_iter)
{
  GtkTextIter s_iter, e_iter;

  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(buffer), &s_iter);
  gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(buffer), &e_iter);
  gtk_text_buffer_remove_tag_by_name (buffer,"highlight_tag",&s_iter,&e_iter);

  my_iter_line_star(sl_iter);
  gtk_text_iter_forward_to_line_end(el_iter);
  gtk_text_buffer_apply_tag_by_name (buffer, "highlight_tag", sl_iter, el_iter);  
}

void highlight_line_buffer(GtkTextBuffer *buffer, gint linen)
{
  GtkTextIter s_iter, e_iter, sl_iter, el_iter;

  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(buffer), &s_iter);
  gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(buffer), &e_iter);
  gtk_text_buffer_remove_tag_by_name (buffer,"highlight_tag",&s_iter,&e_iter);

  gtk_text_buffer_get_iter_at_line(buffer, &sl_iter, linen);
  el_iter=sl_iter;
  gtk_text_iter_forward_to_line_end(&el_iter);
  gtk_text_buffer_apply_tag_by_name (buffer, "highlight_tag", &sl_iter, &el_iter);  
}

void highlight_cur_line_buffer(GtkTextBuffer *buffer)
{
  highlight_line_buffer(buffer,get_cur_line_buffer(buffer));
}

void highlight_end_line_buffer(GtkTextBuffer *buffer)
{
  GtkTextIter iter;
  gtk_text_buffer_get_end_iter(buffer,&iter);
  gtk_text_iter_backward_line (&iter);
  gtk_text_buffer_place_cursor(buffer,&iter);
  highlight_cur_line_buffer(buffer);
}

void set_device_list(void){
  gint i;
  get_device_list(out_device_c, device_list);
  for ( i = 0; i < devIDn; i++ )
    gtk_combo_box_remove_text(GTK_COMBO_BOX(comboboxentry1), 0);
  for( i=0; i < DEVICE_LIST_MAX-1 && device_list[i][0] != '\0';i++){
    gtk_combo_box_append_text(GTK_COMBO_BOX(comboboxentry1), device_list[i]);
    sscanf(device_list[i], "%d ", &(devID[i]));
  }
  gtk_combo_box_append_text(GTK_COMBO_BOX(comboboxentry1), _("(default device)"));
  devID[i++]=-1;
  devIDn = i;
}


/*
void cr_add_buffer(GtkTextBuffer *buffer)
{
  gchar *buf;
  GtkTextIter s_iter,e_iter;

  gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(buffer),&e_iter);
  s_iter=e_iter;
  gtk_text_iter_backward_word_start(&s_iter);
 buf = gtk_text_buffer_get_text(GTK_TEXT_BUFFER(buffer), 
        &s_iter, &e_iter, TRUE);
 if( buf[strlen(buf)-1] != '\n'){
 	gtk_text_iter_forward_to_line_end( &s_iter);
    gtk_text_buffer_insert(GTK_TEXT_BUFFER(buffer),&s_iter,"\n",strlen("\n"));
  }
  g_free(buf);
}
*/


gchar *getline_buffer(GtkTextBuffer *buffer, gint line_number)
{  
  GtkTextIter sl_iter,el_iter;
  gchar *line, *outline;

//  add_cr_buffer(buffer);
  gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(buffer),&sl_iter,line_number);
  gtk_text_buffer_get_iter_at_line(GTK_TEXT_BUFFER(buffer),&el_iter,line_number+1);

  line=gtk_text_buffer_get_text(GTK_TEXT_BUFFER(buffer), 
        &sl_iter, &el_iter, FALSE);
  if (line == NULL){
      //rm_cr_buffer(buffer);
      return NULL;
  }
  outline=(gchar *)g_malloc((strlen(line)+2)*sizeof(gchar));
  strcpy(outline,line);
  if ( ((strlen(outline)-1)>=0) && (*(outline+strlen(outline)-1)!='\n') )strcat(outline,"\n");
  g_free(line);

//  rm_cr_buffer(buffer);
  return outline;
}
gint search_buffer(const GtkTextBuffer *buffer, const char *key, gboolean forward)
{
  gint i, linen;
  GtkTextIter s_iter,e_iter;
  gchar *text, *p, *cp, *cpp;

  if( *key=='\0' ) return - 1;
  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(buffer),&s_iter);
  gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(buffer),&e_iter);
  text=gtk_text_buffer_get_text(GTK_TEXT_BUFFER(buffer), 
        &s_iter, &e_iter, TRUE);

  if ( (text==NULL) || ((p=strstr(text,key))==NULL) ) { g_free(text); return -1;}
  if ( forward != TRUE) {
    cp = p;
    while( (cp=strstr(cp,key))!=NULL ){ p=cp; };  
  }
  linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(buffer));
  for( i = -1,cp=text; (i < linen) && (p > cp); i++){
  	   cpp = strstr(cp,"\n");
       cp = cpp+1;
  }
   g_free(text);
   return i;
}

gint case_search_buffer(const GtkTextBuffer *buffer, const char *key, gboolean forward)
{
  gint i,linen;
  gchar key1[256];
  GtkTextIter s_iter,e_iter;
  gchar *text, *p, *cp, *cpp;
 if( *key=='\0' ) return - 1;
  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(buffer),&s_iter);
  gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(buffer),&e_iter);
  text=gtk_text_buffer_get_text(GTK_TEXT_BUFFER(buffer), 
        &s_iter, &e_iter, TRUE);

  for(i=0;i<(gint)strlen(text);i++) *(text+i)=toupper(*(text+i));
  strcpy(key1, key);
  for(i=0;i<(gint)strlen(key1);i++) *(key1+i)=toupper(*(key1+i));

  if ( (text==NULL) || ((p=strstr(text,key1))==NULL) ) { g_free(text); return -1;}
  if ( forward != TRUE) {
    cp = p;
    while( (cp=strstr(cp,key1))!=NULL ){ p=cp; };  
  }
  linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(buffer));
  for( i = -1,cp=text; ( (i < linen) && (p > cp) ); i++){
  	   cpp = strstr(cp,"\n");
       cp = cpp+1;
  }
   g_free(text);
   return i;
}

gboolean get_sel_num_buffer(GtkTextBuffer *buffer, gint *start, gint *end)
{
  GtkTextIter s_iter, e_iter;
  if( TRUE != gtk_text_buffer_get_selection_bounds(buffer, &s_iter, &e_iter) )
    return FALSE;
  *start = gtk_text_iter_get_line(&s_iter);
  *end = gtk_text_iter_get_line(&e_iter);
  return TRUE;
}
void update_sf2_sel_buffer(void)
{

gint linen, i;
GtkTextIter sl_sf2_iter, el_sf2_iter;
gchar buf[2048],buf2[256];
gchar *line_text;
GtkTextIter iter;

buf[0] = '\0';

gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(sf2_sel_buffer),&sl_sf2_iter,0);
gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(sf2_sel_buffer), &el_sf2_iter);
gtk_text_buffer_delete(GTK_TEXT_BUFFER(sf2_sel_buffer),&sl_sf2_iter,&el_sf2_iter);

linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(dir_buffer));
for( i = 0; (i < linen); i++){
  line_text=getline_buffer(GTK_TEXT_BUFFER(dir_buffer), i);
  strcpy(buf2,line_text);
  g_free(line_text);
  if (buf2[0]=='\"') strcpy(buf2,buf2+1);
  if (( buf2[0] != '\0') && (buf2[strlen(buf2)-1]=='\n')) buf2[strlen(buf2)-1]='\0' ;
  if (( buf2[0] != '\0') && (buf2[strlen(buf2)-1]=='\"')) buf2[strlen(buf2)-1]='\0' ;
  convert_to_utf8(buf2,FALSE);
  dir_list(buf2,".sf2", buf+strlen(buf), 2048-strlen(buf));
  dir_list(buf2,".cfg", buf+strlen(buf), 2048-strlen(buf));
  dir_list(buf2,".SF2", buf+strlen(buf), 2048-strlen(buf));
  dir_list(buf2,".CFG", buf+strlen(buf), 2048-strlen(buf));
}
gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(sf2_sel_buffer), &iter);
gtk_text_buffer_place_cursor(GTK_TEXT_BUFFER(sf2_sel_buffer), &iter);
if (buf[0] != '\0')
  gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(sf2_sel_buffer), buf, strlen(buf));

highlight_end_line_buffer(sf2_sel_buffer);


gtk_text_buffer_set_modified (sf2_sel_buffer, FALSE);
}

void clear_buffer(GtkTextBuffer *buffer)
{
  GtkTextIter s_iter, e_iter, iter;

  gtk_text_buffer_get_start_iter(GTK_TEXT_BUFFER(buffer), &s_iter);
  gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(buffer), &e_iter);
  gtk_text_buffer_delete(GTK_TEXT_BUFFER(buffer), &s_iter, &e_iter);
  gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(buffer), &iter);
  gtk_text_buffer_place_cursor(GTK_TEXT_BUFFER(buffer), &iter);
}

void update_cfg_buffer(void)
{
  gint i, linen;
  gchar *buf;
  gchar buf2[128];

add_cr_buffers();


  clear_buffer(GTK_TEXT_BUFFER(cfg_buffer));

  linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(comment_buffer));
  for(i=0 ; i< linen; i++){
    buf = getline_buffer(GTK_TEXT_BUFFER(comment_buffer), i);
    if( (buf[0] !='\0') && ( buf[0] !='\n'))
      gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), buf, strlen(buf));
    g_free(buf);
  }


  linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(dir_buffer));
  for(i=0 ; i< linen; i++){
    buf = getline_buffer(GTK_TEXT_BUFFER(dir_buffer), i);
    if( (buf[0] !='\0') && ( buf[0] !='\n')){
     sprintf(buf2, "dir %s", buf);    
     gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), buf2, strlen(buf2));
    }
    g_free(buf);
  }
  gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), "\n", strlen("\n"));

  linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(sf2_buffer));
  for(i=0 ; i< linen; i++){
    if( NULL != (buf = getline_buffer(GTK_TEXT_BUFFER(sf2_buffer), i)) ){
 	  if ( (NULL != strstr(buf,".cfg")) || (NULL != strstr(buf,".CFG")) ){
        sprintf(buf2, "source %s", buf);      
        gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), buf2, strlen(buf2));
	  }
	  if ( (NULL != strstr(buf,".sf2")) || (NULL != strstr(buf,".SF2")) ){
        sprintf(buf2, "soundfont %s", buf);    
        gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), buf2, strlen(buf2));
      }
    g_free(buf);
    }
  }

  gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), "\n", strlen("\n"));


  linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(other_syntax_buffer));
  for(i=0 ; i< linen; i++){
    buf = getline_buffer(GTK_TEXT_BUFFER(other_syntax_buffer), i);
    if( (buf[0] !='\0') && ( buf[0] !='\n'))
      gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), buf, strlen(buf));
    g_free(buf);
  }
  	
  gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), "\n", strlen("\n"));

  linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(extension_buffer));
  for(i=0 ; i< linen; i++){
    buf = getline_buffer(GTK_TEXT_BUFFER(extension_buffer), i);
    if( (buf[0] !='\0') && ( buf[0] !='\n'))
      gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), buf, strlen(buf));
    g_free(buf);
  }

  if(latency !=-1){
  	 sprintf(buf2, "#extension opt --rtsyn-latency=%lf\n", latency);
     gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), buf2, strlen(buf2));
  }
  sprintf(buf2, "#extension opt -O%c%s\n", out_device_c, output_format);
  gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), buf2, strlen(buf2));
  if(deviceID !=-1){
  	 sprintf(buf2, "#extension opt --output-device=%d\n", deviceID);
     gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), buf2, strlen(buf2));
  }
  gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer),
      "#extension opt -U\n", strlen("#extension opt -U\n"));

  linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(other_buffer));
  for(i=0 ; i< linen; i++){
    buf = getline_buffer(GTK_TEXT_BUFFER(other_buffer), i);
    if( NULL == strstr( buf, "#extension opt -U"))    
      gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(cfg_buffer), buf, strlen(buf));
    g_free(buf);
  }

rm_cr_buffers();

}

gint saveconfig_buffer(void)
{
 
  gchar buf[MAX_LINE];
  gchar *linebuf;
  gint linen, i;
  FILE *fp;

  update_cfg_buffer();

  if(NULL == (fp = fopen(get_cfg_path(), "w"))) return -1;
  linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(cfg_buffer));
  for(i=0 ; i< linen; i++){
	if( NULL != (linebuf = getline_buffer(GTK_TEXT_BUFFER(cfg_buffer),i))){
      strcpy(buf, linebuf);
      buf[MAX_LINE-1]='\0';
      convert_to_utf8(buf, FALSE);
      buf[MAX_LINE-1]='\0';
      fputs(buf,fp);
      g_free(linebuf);
	}
  }
  fclose(fp);
  return 0;
}

void rmstr_string(gchar *str, gchar *key)
{
    gchar *cp;
    cp=str;
 	while ((cp=strstr(cp, key) ) !=NULL){
	  strcpy( cp, cp+strlen(key));
	}
}

void update_out_buttons(void){

  if(out_device_c=='d')
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(out_winmm_btn),TRUE);
  if(out_device_c=='p')
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(out_pa_win_btn),TRUE);
  if(out_device_c=='P')
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(out_pa_directx_btn),TRUE);
  if(out_device_c=='o')
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(out_pa_asio_btn),TRUE);

};

void set_deviceID(int deviceID)
{
  int i;
  set_device_list();
  for ( i = 0; i < devIDn; i++ ){
    if (deviceID == devID[i]) break;
  }
  if(i != devIDn){
    gtk_combo_box_set_active(GTK_COMBO_BOX(comboboxentry1),i);
  }else{
    deviceID=-1;
  }
}

void reduce_space(char *buf){
  char *p, *pp, *ppp;

  for( p = buf; p < buf+strlen(buf); p++){
	  if( *p == '\t') *p = ' ';
  }
  p=buf;
  while ( (NULL != (pp = strstr(p, " "))) && (p<buf+strlen(buf)) ){
    ppp=pp;
	while( *ppp == ' ') ppp++;
	strcpy(pp+1, ppp);
	p=pp+1;
  }
}

void rm_comment(char *buf){
  char *p;
  reduce_space(buf);
  if( NULL != (p = strstr(buf, " #"))) *p='\0';
}

void parse_one_line(char *buf)
{
  gchar *cp,buf2[256];
  gboolean parsed;
  gboolean quoted = FALSE;

    if (strstr(buf, "\"") != NULL) quoted = TRUE;
    rm_comment(buf);
    if( *(buf+strlen(buf)-1) != '\n' ) strcat(buf,"\n");
    parsed = FALSE;
	if ( strncmp(buf, "dir ", strlen("dir ")) == 0){
	  char *p, *pp;
      rmstr_string(buf, "\"");
      rmstr_string(buf, "dir ");
	  *(buf+strlen(buf)-1)='\0';
	  sprintf(buf2,"\"%s\"\n",buf);
	  p=buf2;
	  while( (p < buf2+strlen(buf2)) && (NULL != (pp = strstr(p, "/"))) ){
	    *pp = G_DIR_SEPARATOR;
		p = pp+1;
	  }       
      gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(dir_buffer), buf2, strlen(buf2));
      parsed = TRUE;
	}
	if ( strncmp(buf, "source ", strlen("source ")) == 0){
      char *p;
      rmstr_string(buf, "source ");
	  *(buf+strlen(buf)-1)='\0';
      if(TRUE == quoted){
        if( NULL != (p=strstr(buf,"\" ")) ){
          p++;
          *p++='\0';
          sprintf(buf2,"%s %s\n",buf,p);
        }else{
	      sprintf(buf2,"%s\n",buf);
        }
      }else{
        if( NULL != (p=strstr(buf," ")) ){
          *p++='\0';
          sprintf(buf2,"\"%s\" %s\n",buf,p);
        }else{
	      sprintf(buf2,"\"%s\"\n",buf);
        }
      }
      gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(sf2_buffer), buf2, strlen(buf2));
      parsed = TRUE;
	}
	if ( strncmp(buf, "soundfont ", strlen("soundfont ")) == 0){
      rmstr_string(buf, "soundfont ");
      if ( ( (cp = strstr( buf, ".sf2")) != NULL ) || ( (cp = strstr( buf, ".SF2")) != NULL ) ){
        char *p;
	    *(buf+strlen(buf)-1)='\0';
        if(TRUE == quoted){
          if( NULL != (p=strstr(buf,"\" ")) ){
            p++;
            *p++='\0';
            sprintf(buf2,"%s %s\n",buf,p);
          }else{
	        sprintf(buf2,"%s\n",buf);
          }
        }else{
          if( NULL != (p=strstr(buf," ")) ){
            *p++='\0';
            sprintf(buf2,"\"%s\" %s\n",buf,p);
          }else{
	        sprintf(buf2,"\"%s\"\n",buf);
          }
        }
        gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(sf2_buffer), buf2, strlen(buf2));
        parsed = TRUE;
      }
    }

	if ( strncmp(buf, "#extension opt ", strlen("#extension opt ")) == 0){    
	  if ((cp = strstr(buf, "--rtsyn-latency="))!=NULL){
        if( sscanf(cp+strlen("--rtsyn-latency="), "%lf", &latency) != EOF )
          parsed = TRUE;
      }
	  if ((cp = strstr(buf, "--output-mode="))!=NULL){
        if( sscanf(cp+strlen("--output-mode="), "%c", &out_device_c) != EOF )
          parsed = TRUE;
      }
	  if ((cp = strstr(buf, "-O"))!=NULL){
        if( sscanf(cp+strlen("-O"), "%c", &out_device_c) != EOF ){
          gchar *p;
          strcpy(output_format,cp+strlen("-O")+1);
          rmstr_string(output_format, "\n");
          p=strstr(output_format,"d");
          if(p != NULL) {
            if (sscanf(p+1, "%d", &deviceID) != EOF ){
              *(p)='\0';
            }
          }
        }
        parsed = TRUE;
      }
      if ((cp = strstr(buf, "--output-device="))!=NULL){
        if( sscanf(cp+strlen("--output-device="), "%d", &deviceID) != EOF ){
          parsed = TRUE;
        }
      }
      if (parsed != TRUE){
           gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(other_buffer), buf, strlen(buf));
            parsed = TRUE;
      } 
    }
	if ( (parsed != TRUE) && ( strncmp(buf, "#extension ", strlen("#extension ")) == 0) ){     
      gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(extension_buffer), buf, strlen(buf));
      parsed = TRUE;
    }
    if( (parsed != TRUE) && (buf[0] == '#') ){
      gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(comment_buffer), buf, strlen(buf));
      parsed = TRUE;
    }
    if( (parsed != TRUE) && ((buf[0] != '#') && (buf[0] != '\n')) ){
      gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(other_syntax_buffer), buf, strlen(buf));
      parsed = TRUE;
    }
}


void apply_config_buffer(void)
{
  int i, linen;
  char *buf;
  gint bufID;

  latency= -1;
  out_device_c='d';
  output_format[0]='\0';
  deviceID = -1;

  clear_buffer(GTK_TEXT_BUFFER(dir_buffer));
  clear_buffer(GTK_TEXT_BUFFER(sf2_buffer));
  clear_buffer(GTK_TEXT_BUFFER(other_buffer));
  clear_buffer(GTK_TEXT_BUFFER(other_syntax_buffer));
  clear_buffer(GTK_TEXT_BUFFER(comment_buffer));
  clear_buffer(GTK_TEXT_BUFFER(extension_buffer));


  linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(cfg_buffer));
  for(i=0 ; i< linen; i++){
    buf=getline_buffer(GTK_TEXT_BUFFER(cfg_buffer), i);
	if(buf != NULL){
	parse_one_line(buf);
    g_free(buf);
	}
  }
  update_sf2_sel_buffer();

  if ( latency != -1){
    sprintf(buf, "%lf",latency);
    gtk_entry_set_text(GTK_ENTRY(entry2),buf);
  }else{
    gtk_entry_set_text(GTK_ENTRY(entry2),"");
  }
  
  bufID=deviceID;
  update_out_buttons();
  deviceID=bufID;
  set_deviceID(deviceID);

  highlight_end_line_buffer(dir_buffer);
  highlight_end_line_buffer(sf2_sel_buffer);
  highlight_end_line_buffer(sf2_buffer);


rm_cr_buffers();

}

gint readconfig_buffer(void)
{
  FILE *fp;
  gchar buf[MAX_LINE];
  gint bufID;

  latency= -1;
  out_device_c='d';
  output_format[0]='\0';
  deviceID = -1;

  clear_buffer(GTK_TEXT_BUFFER(dir_buffer));
  clear_buffer(GTK_TEXT_BUFFER(sf2_buffer));
  clear_buffer(GTK_TEXT_BUFFER(other_buffer));
  clear_buffer(GTK_TEXT_BUFFER(other_syntax_buffer));
  clear_buffer(GTK_TEXT_BUFFER(comment_buffer));
  clear_buffer(GTK_TEXT_BUFFER(extension_buffer));


  if((fp = fopen(get_cfg_path(), "r"))==NULL) return -1;
  while( NULL != fgets(buf,256,fp) ){
    buf[MAX_LINE-1]='\0';
    convert_to_utf8(buf, TRUE);
    buf[MAX_LINE-1]='\0';
	parse_one_line(buf);
  };
  update_sf2_sel_buffer();
  update_cfg_buffer();
  if ( latency != -1){
    sprintf(buf, "%lf",latency);
    gtk_entry_set_text(GTK_ENTRY(entry2),buf);
  }else{
    gtk_entry_set_text(GTK_ENTRY(entry2),"");
  }

  bufID=deviceID;
  update_out_buttons();
  deviceID=bufID;
  set_deviceID(deviceID);

  highlight_end_line_buffer(dir_buffer);
  highlight_end_line_buffer(sf2_sel_buffer);
  highlight_end_line_buffer(sf2_buffer);

  fclose(fp);

  update_cfg_buffer();

rm_cr_buffers();
  

  return 0;
}


void dir_add(const gchar *dir_path)
{
GtkTextIter iter;
gchar buf[256], buf_u[256],linebuf_u[256];
gint i, linen, j;
gchar *linebuf;
gboolean found;



strcpy(buf,dir_path);
convert_to_utf8(buf,FALSE);
if ( FALSE == is_dir(buf) ) return;

sprintf(buf,"\"%s\"",dir_path);



found = FALSE;
linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(cfg_buffer));
for(j=0 ; j<linen ;j++ ){
 linebuf = getline_buffer(GTK_TEXT_BUFFER(dir_buffer), j);
 for (i =0; i <= (gint) strlen(buf); i++) *(buf_u+i)= toupper(*(buf+i));
 for (i =0; i <= (gint) strlen(linebuf); i++) *(linebuf_u+i)=toupper(*(linebuf+i));
 if ( 0 ==strncmp(linebuf_u,buf_u,strlen(buf_u)) ) found = TRUE;
 g_free(linebuf);
}
if( found == FALSE ){
   gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(dir_buffer), &iter);
   gtk_text_buffer_place_cursor(GTK_TEXT_BUFFER(dir_buffer), &iter);
   gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(dir_buffer), buf, strlen(buf));
   gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(dir_buffer), "\n", strlen("\n"));
 

}

highlight_end_line_buffer(dir_buffer);


update_sf2_sel_buffer();
update_cfg_buffer();


gtk_text_buffer_set_modified (dir_buffer, FALSE);
gtk_text_buffer_set_modified (sf2_sel_buffer, FALSE);
}

void sf2_add(const gchar *sf2_name)
{
GtkTextIter iter;
gchar buf[258];


if (*sf2_name == '\0' ){
  return;
}
if ( 0 == strcmp(sf2_name,"timidity.cfg") ){
  return;
}
sprintf(buf,"\"%s\"",sf2_name);
//cr_add_buffer(GTK_TEXT_BUFFER(sf2_buffer));
if ( -1 == search_buffer((const GtkTextBuffer *)sf2_buffer,(const char *)sf2_name, TRUE)){
 gtk_text_buffer_get_end_iter(GTK_TEXT_BUFFER(sf2_buffer), &iter);
 gtk_text_buffer_place_cursor(GTK_TEXT_BUFFER(sf2_buffer), &iter);
 gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(sf2_buffer), buf, strlen(buf));
 gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(sf2_buffer), "\n", strlen("\n"));
} 

highlight_end_line_buffer(sf2_buffer);

//gtk_text_buffer_set_modified (sf2_buffer, FALSE);

update_cfg_buffer();

}

gboolean find_full_acp_path(gchar *path)
{
   gint i, linen;
   gchar buf[2048], buf2[256], path_buf[256], returndir[256];
   gchar *line_text;

  if( (path==NULL) || (path[0] == '\0') ) return FALSE;

  if (path[0]=='\"') strcpy(path,path+1);
  if (path[strlen(path)-1]=='\n') path[strlen(path)-1]='\0' ;
  if (path[strlen(path)-1]=='\"') path[strlen(path)-1]='\0' ;

   linen = gtk_text_buffer_get_line_count(GTK_TEXT_BUFFER(dir_buffer));
  for( i = 0; i < linen; i++){
    buf[0]='\0';
    line_text=getline_buffer(GTK_TEXT_BUFFER(dir_buffer), i);
    strncpy(buf2,line_text,256-1);
    g_free(line_text);
    if (buf2[0]=='\"') strcpy(buf2,buf2+1);
    if (( buf2[0] != '\0') && (buf2[strlen(buf2)-1]=='\n')) buf2[strlen(buf2)-1]='\0' ;
    if (( buf2[0] != '\0') && (buf2[strlen(buf2)-1]=='\"')) buf2[strlen(buf2)-1]='\0' ;
    convert_to_utf8(buf2,FALSE);
    dir_list(buf2,NULL, buf+strlen(buf), 2048-strlen(buf));
    memmove(buf+1,buf,strlen(buf));
    buf[0]='\n';
    sprintf(path_buf,"\n%s\n",path); 
    if( NULL != strstr(buf,path_buf)) {
      sprintf(returndir, "%s\\%s", buf2,path);
      strcpy(path,returndir);
//      printf("%s\n",path);
      return TRUE;
    }
  }
  return FALSE;
}

void show_syntax(GtkTextBuffer *buffer, gint line){
  gchar *buf, *locale;
  gchar url[256], buf2[256],currentdir[256];
  gboolean parsed=FALSE;
  gint num, num2;
  gchar *p, *pp;

  

  locale =setlocale(LC_ALL, NULL);
  strcpy(url,"file:///");
  GetModuleFileName(NULL,currentdir,256);
  p=currentdir+strlen(currentdir)-1;
  while( p >= currentdir && *p != G_DIR_SEPARATOR ) p--;
  if(p >=currentdir)  *p='\0';
   p=currentdir;
  while( (p < currentdir+strlen(currentdir)) && (NULL!=(pp=strstr(p,G_DIR_SEPARATOR_S))) ){
    *pp='/';
    p=++pp;
  }
  //convert_to_urlencode(currentdir,TRUE);  not work with "iexplore"
  strcat(url,currentdir);
  if( 0 == strcmp(locale,"Japanese_Japan.932")){
    strcat(url,"/help/timidity_cfg_ja.htm#");
  }else{
    strcat(url,"/timidity_cfg.htm#");
  }

  parsed=FALSE;

  buf=getline_buffer(buffer,line);

  if ( (parsed == FALSE) && (1 == sscanf(buf, "#extension %s ", buf2)) ){
    strcat(url,buf2);
    ShellExecute(NULL,NULL, open_browser, url, NULL, SW_SHOWNORMAL);
    parsed=TRUE;
  }	 
 if ( (parsed == FALSE) && (2 == sscanf(buf, "bank %d %d", &num, &num2)) ){
    strcat(url,"bank_num_prog");
    ShellExecute(NULL,NULL, open_browser, url, NULL, SW_SHOWNORMAL);
    parsed=TRUE;
 } 
 if ( (parsed == FALSE) && (1 == sscanf(buf, "%d ", &num)) ){
    strcat(url,"prog");
    ShellExecute(NULL,NULL, open_browser, url, NULL, SW_SHOWNORMAL);
    parsed=TRUE;
  }        
  if ( (parsed == FALSE) && (1 == sscanf(buf, "%s ", buf2)) ){
    if ( 0 == strncmp(buf2, "#", strlen("#")) ) parsed=TRUE;
    if ( TRUE != parsed ){  
      strcat(url,buf2);
      ShellExecute(NULL,NULL, open_browser, url, NULL, SW_SHOWNORMAL);
      parsed=TRUE;
    }  
  }	 
  g_free(buf);

  
}
void next_action(GtkTextBuffer *buffer, gint line){
  gchar *buf, *p, *pp, *cfg_exe_name, *cfg_dir_path, *sf2_exe_name, *sf2_dir_path;
  gchar  buf2[256],cfg_buf[256],sf2_buf[256];
  gboolean parsed=FALSE;


  strncpy(cfg_buf,cfg_editor_path,256-1);
  p=cfg_buf;
  while( NULL!=(pp=strstr(p,"\\")) ) p=++pp;
  if(p != cfg_buf){
    *(p-1)='\0';
    cfg_exe_name=p;
    cfg_dir_path=cfg_buf;
  }else{
    cfg_exe_name=cfg_buf;
    cfg_dir_path=NULL;
  }

  strncpy(sf2_buf,sf2_editor_path,256-1);
  p=sf2_buf;
  while( NULL!=(pp=strstr(p,"\\")) ) p=++pp;
  if(p != sf2_buf){
    *(p-1)='\0';
    sf2_exe_name=p;
    sf2_dir_path=sf2_buf;
  }else{
    sf2_exe_name=sf2_buf;
    sf2_dir_path=NULL;
  }

  parsed=FALSE;

  buf=getline_buffer(buffer,line);

  if ( (parsed == FALSE) && (1 == sscanf(buf, "source %s ", buf2)) ){
    if( TRUE == find_full_acp_path(buf2) ){
      if( *cfg_editor_path != '\0')
        ShellExecute(NULL,NULL, cfg_exe_name, buf2, cfg_dir_path, SW_SHOWNORMAL);
      parsed=TRUE;
    }
  }
  if ( (parsed == FALSE) && (1 == sscanf(buf, "soundfont %s ", buf2)) ){
    if( TRUE == find_full_acp_path(buf2) ){
      if( *sf2_editor_path != '\0')
        ShellExecute(NULL,NULL, sf2_exe_name, buf2, sf2_dir_path, SW_SHOWNORMAL);
      parsed=TRUE;
    }
  }

  g_free(buf);

  
}
void inifile_read(void)
{
 GError *error=NULL;
 gchar *buf, *p;
 gsize length;
 FILE *fp;

  GetModuleFileName(NULL,inifile_name, 256);
  p=inifile_name+strlen(inifile_name)-1;
  while( p >= inifile_name && *p != G_DIR_SEPARATOR ) p--;
  if(p >=inifile_name)  *p='\0';
  strncpy(cfg_editor_path,inifile_name,256);
  strncpy(sf2_editor_path,inifile_name,256);
  strncat(inifile_name,G_DIR_SEPARATOR_S,1);
  strncat(inifile_name,INIFILE_NAME,strlen(INIFILE_NAME));

  strncat(cfg_editor_path,"\\wscite\\SciTE.exe", strlen("\\wscite\\SciTE.exe") );
  if ( NULL != (fp = fopen( cfg_editor_path, "r")) ){
    fclose(fp);
  }else{
    strncpy(cfg_editor_path, "", 256-1);
  }
  strncat(sf2_editor_path,"\\swami.exe", strlen("\\swami.exe") );
  if ( NULL != (fp = fopen( sf2_editor_path, "r")) ){
    fclose(fp);
  }else{
    strncpy(sf2_editor_path, "", 256-1);
  }

  inifile=g_key_file_new();
  if( TRUE == g_key_file_load_from_file( inifile, inifile_name, G_KEY_FILE_NONE , &error)){
    buf = g_key_file_get_locale_string (inifile, "options", "cfg_editor_path", "C", &error);
    if( buf != NULL) strncpy(cfg_editor_path,buf,256-1);
    buf = g_key_file_get_locale_string (inifile, "options", "sf2_editor_path", "C", &error);
    if( buf != NULL) strncpy(sf2_editor_path,buf,256-1);
  }


}
void inifile_write(void)
{
  gchar *keydata;
  gsize length;
  GError *error=NULL;
  FILE *fp;

  g_key_file_set_locale_string (inifile, "options", "cfg_editor_path", "C", cfg_editor_path);
  g_key_file_set_locale_string (inifile, "options", "sf2_editor_path", "C", sf2_editor_path);


  keydata=g_key_file_to_data(inifile, &length, &error);
  if ( NULL != (fp=fopen( inifile_name,"w")) ){
    fprintf(fp,"%s",keydata);
    fclose(fp);
  }
  g_free(keydata);
}
void get_open_browser(void)
{
  LONG lResult;
  DWORD dwDisposition;
  HKEY hKeyResult;
  DWORD dwType = REG_SZ;
  DWORD dwData;
  gchar *p, *pp;

  if( 0 != (lResult = RegCreateKeyEx(HKEY_CLASSES_ROOT, "http\\shell\\open\\command",
     0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
     NULL, &hKeyResult,&dwDisposition)) )
    goto err;
  dwData=sizeof(open_browser);
  RegQueryValueEx(hKeyResult, 0, NULL, &dwType, (LPBYTE)open_browser, &dwData);
 
  p=open_browser;
  if ( (NULL == (pp=strstr(p,".EXE"))) && (NULL == (pp=strstr(p,".exe"))) )
    goto err;
  *(pp+4)='\0';
  while( pp >= open_browser && *pp != '\\') pp--;
  memmove(open_browser, pp+1, strlen(pp+1)+1);
  return;

err:
    strncpy(open_browser,"iexplore",sizeof(open_browser));
    return ;

}


 
void
on_entry1_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_file_chooser_set_action(GTK_FILE_CHOOSER(dir_select_dlg),GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
  gtk_widget_show (dir_select_dlg);
}




gboolean
on_textview4_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_textview4_button_release_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
gint dir_cline;
GtkTextIter dir_iter;
gint x, y, buffer_x, buffer_y;
/*
gtk_widget_get_pointer(widget, &x, &y);
gtk_text_view_window_to_buffer_coords(GTK_TEXT_VIEW(widget),
        GTK_TEXT_WINDOW_WIDGET,  x, y, &buffer_x, &buffer_y);
gtk_text_view_get_iter_at_location(GTK_TEXT_VIEW(widget),&dir_iter,buffer_x,buffer_y);
my_iter_line_star(&dir_iter);
dir_cline = gtk_text_iter_get_line(&dir_iter);
*/
dir_cline = get_cur_line_buffer(dir_buffer);
highlight_line_buffer(gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget)),dir_cline);
gtk_text_buffer_set_modified (dir_buffer, FALSE);
  return FALSE;
}


void
on_dir_add_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{
const gchar* name;

add_cr_buffers();

name = gtk_entry_get_text(GTK_ENTRY(entry1));
dir_add(name);

rm_cr_buffers();

}


void
on_dir_remove_pressed                  (GtkButton       *button,
                                        gpointer         user_data)
{
GtkTextIter sl_iter, el_iter, iter;
gint dir_cline, offset;

if (gtk_text_buffer_get_modified (dir_buffer) == TRUE)  return;

add_cr_buffers();


if ( TRUE == gtk_text_buffer_get_selection_bounds(GTK_TEXT_BUFFER(dir_buffer), &sl_iter, &el_iter) ){
  gtk_text_iter_forward_line(&el_iter);
  gtk_text_iter_forward_line(&sl_iter);
  gtk_text_iter_backward_line(&sl_iter);
}else{
//  sl_iter=dir_iter;
//  el_iter=dir_iter;
//  gtk_text_iter_forward_line(&el_iter);
dir_cline=get_cur_line_buffer(dir_buffer);
gtk_text_buffer_get_iter_at_line(dir_buffer,&sl_iter,dir_cline);
gtk_text_buffer_get_iter_at_line(dir_buffer,&el_iter,dir_cline+1);
}

iter=sl_iter;
gtk_text_iter_backward_line (&iter);
offset = gtk_text_iter_get_line(&iter);

gtk_text_buffer_delete(GTK_TEXT_BUFFER(dir_buffer),&sl_iter,&el_iter);

gtk_text_buffer_get_iter_at_line(dir_buffer,&iter, offset);
gtk_text_buffer_place_cursor(dir_buffer,&iter);
highlight_cur_line_buffer(dir_buffer);


update_sf2_sel_buffer();
update_cfg_buffer();


rm_cr_buffers();
}


gboolean
on_textview2_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_textview2_button_release_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
GtkTextIter sf2_iter, el_iter, sl_iter;
gint x, y, buffer_x, buffer_y;
gint sf2_cline;

/*
gtk_widget_get_pointer(widget, &x, &y);
gtk_text_view_window_to_buffer_coords(GTK_TEXT_VIEW(widget),
        GTK_TEXT_WINDOW_WIDGET,  x, y, &buffer_x, &buffer_y);
gtk_text_view_get_iter_at_location(GTK_TEXT_VIEW(widget),&sf2_iter,buffer_x,buffer_y);
my_iter_line_star(&sf2_iter);
sf2_cline = gtk_text_iter_get_line(&sf2_iter);
*/
if ( TRUE == gtk_text_buffer_get_selection_bounds(GTK_TEXT_BUFFER(sf2_buffer), &sl_iter, &el_iter)){
//  highlight_range_buffer(sf2_buffer,&sl_iter, &el_iter);
}else{
  highlight_cur_line_buffer(gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget)));
}
gtk_text_buffer_set_modified (sf2_buffer, FALSE);
  return FALSE;
}


void
on_sf2_add_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{
//GtkTextIter sl_iter, el_iter;
gint linen, start, end, i;
gchar *line_text;

//cr_add_buffer(GTK_TEXT_BUFFER(sf2_sel_buffer));

if (gtk_text_buffer_get_modified (sf2_sel_buffer) == TRUE) return;

add_cr_buffers();


if (TRUE == get_sel_num_buffer(GTK_TEXT_BUFFER(sf2_sel_buffer), &start, &end) ){
  for( i=start; i <= end ;i++){
    line_text = getline_buffer(GTK_TEXT_BUFFER(sf2_sel_buffer), i);
    line_text[strlen(line_text)-1]='\0';
    sf2_add(line_text);
    g_free(line_text);
  }
}else{
//linen = gtk_text_iter_get_line(&sf2_sel_iter);
//linen = sf2_sel_cline;
linen = get_cur_line_buffer(sf2_sel_buffer);
line_text = getline_buffer(GTK_TEXT_BUFFER(sf2_sel_buffer), linen);
line_text[strlen(line_text)-1]='\0';
sf2_add(line_text);
g_free(line_text);
}

rm_cr_buffers();
}


void
on_sf2_remove_pressed                  (GtkButton       *button,
                                        gpointer         user_data)
{
GtkTextIter sl_iter, el_iter, iter;
gint sf2_cline,offset;

if (gtk_text_buffer_get_modified (sf2_buffer) == TRUE) return;

add_cr_buffers();

if ( TRUE == gtk_text_buffer_get_selection_bounds(GTK_TEXT_BUFFER(sf2_buffer), &sl_iter, &el_iter) ){
gtk_text_iter_forward_line(&el_iter);
gtk_text_iter_forward_line(&sl_iter);
gtk_text_iter_backward_line(&sl_iter);
}else{
sf2_cline=get_cur_line_buffer(sf2_buffer);
gtk_text_buffer_get_iter_at_line(sf2_buffer,&sl_iter,sf2_cline);
gtk_text_buffer_get_iter_at_line(sf2_buffer,&el_iter,sf2_cline+1);
//el_iter=sf2_iter;
//gtk_text_iter_forward_line(&el_iter);
//sl_iter=el_iter;
//gtk_text_iter_backward_line(&sl_iter);
}

iter=sl_iter;
gtk_text_iter_backward_line(&iter);
offset = gtk_text_iter_get_line(&iter);

gtk_text_buffer_delete(GTK_TEXT_BUFFER(sf2_buffer),&sl_iter,&el_iter);

gtk_text_buffer_get_iter_at_line(sf2_buffer,&iter, offset);
gtk_text_buffer_place_cursor(sf2_buffer,&iter);
highlight_cur_line_buffer(sf2_buffer);


update_cfg_buffer();

rm_cr_buffers();

}


void
on_sf2_up_pressed                      (GtkButton       *button,
                                        gpointer         user_data)
{
GtkTextIter to_iter, sl_iter, el_iter,sf2_iter;
gchar *line_text;
gint offset;
gint sf2_cline;

if (gtk_text_buffer_get_modified (sf2_buffer) == TRUE) return;

add_cr_buffers();


//sl_iter=sf2_iter;
//el_iter=sf2_iter;
//gtk_text_iter_forward_line(&el_iter);
sf2_cline = get_cur_line_buffer(sf2_buffer);
gtk_text_buffer_get_iter_at_line(sf2_buffer,&sl_iter,sf2_cline);
gtk_text_buffer_get_iter_at_line(sf2_buffer,&el_iter,sf2_cline+1);
if (gtk_text_iter_is_start(&sl_iter) == TRUE ){
  rm_cr_buffers();
   return;
}
//to_iter = sf2_iter;
gtk_text_buffer_get_iter_at_line(sf2_buffer,&to_iter,sf2_cline);
gtk_text_iter_backward_line(&to_iter);
offset=gtk_text_iter_get_offset(&to_iter);
line_text=gtk_text_buffer_get_text(GTK_TEXT_BUFFER(sf2_buffer), 
        &sl_iter, &el_iter, TRUE);
gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(sf2_buffer), &sl_iter, offset);
gtk_text_iter_forward_line(&sl_iter);
el_iter=sl_iter;
gtk_text_iter_forward_line(&el_iter);
gtk_text_buffer_delete(GTK_TEXT_BUFFER(sf2_buffer),&sl_iter,&el_iter);
gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(sf2_buffer), &to_iter, offset);
gtk_text_buffer_place_cursor(GTK_TEXT_BUFFER(sf2_buffer), &to_iter);
gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(sf2_buffer), line_text, strlen(line_text));
gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(sf2_buffer), &sf2_iter, offset);
gtk_text_buffer_place_cursor(GTK_TEXT_BUFFER(sf2_buffer), &sf2_iter);
sf2_cline--; 
highlight_line_buffer(sf2_buffer, sf2_cline);
g_free(line_text);
update_cfg_buffer();
rm_cr_buffers();
}


void
on_sf2_down_pressed                    (GtkButton       *button,
                                        gpointer         user_data)
{
GtkTextIter to_iter, sl_iter, el_iter, sf2_iter;
gchar *line_text;
gint offset;
gint sf2_cline;

if (gtk_text_buffer_get_modified (sf2_buffer) == TRUE) return;

add_cr_buffers();

sf2_cline=get_cur_line_buffer(sf2_buffer);
gtk_text_buffer_get_iter_at_line(sf2_buffer,&sf2_iter,sf2_cline);
offset=gtk_text_iter_get_offset(&sf2_iter);

sl_iter=sf2_iter;
el_iter=sf2_iter;
if (gtk_text_iter_forward_line(&el_iter) == TRUE ){
  to_iter=el_iter;
  gtk_text_iter_forward_line(&to_iter);
  line_text=gtk_text_buffer_get_text(GTK_TEXT_BUFFER(sf2_buffer), 
        &sl_iter, &el_iter, TRUE);
  gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(sf2_buffer), &to_iter, offset);
  gtk_text_iter_forward_lines(&to_iter,2);
  gtk_text_buffer_place_cursor(GTK_TEXT_BUFFER(sf2_buffer), &to_iter);
  gtk_text_buffer_insert_at_cursor(GTK_TEXT_BUFFER(sf2_buffer), line_text, strlen(line_text));
  gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(sf2_buffer), &sl_iter, offset);
  el_iter=sl_iter;  
  gtk_text_iter_forward_line(&el_iter);
  gtk_text_buffer_delete(GTK_TEXT_BUFFER(sf2_buffer),&sl_iter,&el_iter);
  g_free(line_text);
  gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(sf2_buffer), &sf2_iter, offset);
  gtk_text_iter_forward_line(&sf2_iter);
  gtk_text_buffer_place_cursor(GTK_TEXT_BUFFER(sf2_buffer), &sf2_iter);
  sf2_cline++;
  highlight_line_buffer(sf2_buffer, sf2_cline);
//}else{
  //gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(sf2_buffer), &sf2_iter, offset);
}
update_cfg_buffer();
rm_cr_buffers();
}


gboolean
on_textview3_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_textview3_button_release_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
gint x, y, buffer_x, buffer_y;
GtkTextIter sf2_sel_iter,sl_iter,el_iter;
gint sf2_sel_cline;

/*
gtk_widget_get_pointer(widget, &x, &y);
gtk_text_view_window_to_buffer_coords(GTK_TEXT_VIEW(widget),
        GTK_TEXT_WINDOW_WIDGET,  x, y, &buffer_x, &buffer_y);
gtk_text_view_get_iter_at_location(GTK_TEXT_VIEW(widget),&sf2_sel_iter,buffer_x,buffer_y);
my_iter_line_star(&sf2_sel_iter);

sf2_sel_cline = gtk_text_iter_get_line(&sf2_sel_iter);
*/
if ( TRUE == gtk_text_buffer_get_selection_bounds(GTK_TEXT_BUFFER(sf2_sel_buffer), &sl_iter, &el_iter)){
//  highlight_range_buffer(sf2_sel_buffer,&sl_iter, &el_iter);
}else{
  highlight_cur_line_buffer(gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget)));
}
gtk_text_buffer_set_modified (sf2_sel_buffer, FALSE);
  return FALSE;
}


void
on_entry2_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
const gchar *inbuf;
inbuf=gtk_entry_get_text(GTK_ENTRY(editable));
if (0==sscanf(inbuf,"%lf",&latency) ) latency=-1.0;
update_cfg_buffer();
}


void
on_button15_pressed                    (GtkButton       *button,
                                        gpointer         user_data)
{
asioConfigDialog();

}


void
on_discard_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{
readconfig_buffer();
  set_device_list();
}


void
on_cacel_quit_pressed                  (GtkButton       *button,
                                        gpointer         user_data)
{
inifile_write();
gtk_main_quit(); 
}


void
on_quit_pressed                        (GtkButton       *button,
                                        gpointer         user_data)
{
saveconfig_buffer();
inifile_write();
gtk_main_quit(); 
}


void
on_dir_select_cancel_btn_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(dir_select_dlg);
}


void
on_dir_select_open_btn_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  gchar *dir_name;
  gtk_widget_hide(dir_select_dlg);
  dir_name = gtk_file_chooser_get_current_folder(GTK_FILE_CHOOSER (dir_select_dlg));
  gtk_entry_set_editable(GTK_ENTRY(entry1), TRUE);
  gtk_entry_set_text(GTK_ENTRY(entry1),(const gchar *)dir_name);
  gtk_entry_set_editable(GTK_ENTRY(entry1), FALSE);
  g_free(dir_name);
}


void
on_out_pa_win_btn_clicked              (GtkToggleButton       *button,
                                        gpointer         user_data)
{
}


void
on_out_pa_directx_btn_clicked          (GtkToggleButton      *button,
                                        gpointer         user_data)
{
}


void
on_out_pa_asio_btn_clicked             (GtkToggleButton       *button,
                                        gpointer         user_data)
{
}


void
on_cfg_window_btn_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
update_cfg_buffer();
gtk_widget_hide (cfg_edit_dlg);
gtk_widget_show (cfg_edit_dlg);
}


void
on_out_winmm_btn_clicked               (GtkToggleButton      *button,
                                        gpointer         user_data)
{
}


void
on_dir_select_dlg_destroy              (GtkObject       *object,
                                        gpointer         user_data)
{
gtk_widget_hide (dir_select_dlg);
}


gboolean
on_dir_select_dlg_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_widget_hide (dir_select_dlg);
  return TRUE;
}


void
on_cfg_windows_destroy                 (GtkObject       *object,
                                        gpointer         user_data)
{
apply_config_buffer();
update_cfg_buffer();
gtk_widget_hide (cfg_edit_dlg);
}


gboolean
on_cfg_windows_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
apply_config_buffer();
update_cfg_buffer();
gtk_widget_hide (cfg_edit_dlg);
  return TRUE;
}


void
on_comboboxentry1_changed              (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
  gint n;
  n = gtk_combo_box_get_active (GTK_COMBO_BOX(combobox));
  deviceID=devID[n];
}


void
on_cancel_quit1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
inifile_write();
gtk_main_quit(); 
}


void
on_save_quit1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
saveconfig_buffer();
inifile_write();
gtk_main_quit(); 
}


void
on_timiditycfg1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
char *locale;
gchar buf[256];
gchar *currentdir, *p, *pp;
strcpy(buf,"file:///");
currentdir=buf+8;
GetModuleFileName(NULL,currentdir,256-8);
p=currentdir+strlen(currentdir)-1;
while( p >= currentdir && *p != G_DIR_SEPARATOR ) p--;
if(p >=currentdir)  *p='\0';
p=currentdir;
while( (p < currentdir+strlen(currentdir)) && (NULL!=(pp=strstr(p,G_DIR_SEPARATOR_S))) ){
  *pp='/';
  p=++pp;
}
locale =setlocale(LC_ALL, NULL);
if( 0 == strcmp(locale,"Japanese_Japan.932")){
  strcat(buf,"/help/timidity_cfg_ja.htm");
}else{
  strcat(buf,"/help/timidity_cfg.htm");
}
  ShellExecute(NULL, NULL,buf, 
      NULL, NULL, SW_SHOWNORMAL);
}


gboolean
on_textview2_drag_motion               (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_textview2_drag_data_received        (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{
  GdkDragAction actions;
  gchar text[MAX_LINE*40];
   actions=drag_context->actions;
  if ((actions & GDK_ACTION_COPY) && (data->length > 0) && (data->format == 8)) {
    gint n;
    gchar buf[MAX_LINE];
    gchar *p, *pp, *linep, dir_path[256], filename[256];

    if (data->length > MAX_LINE*40){
      gtk_drag_finish(drag_context, FALSE, FALSE, time);
      return;
    }

    for( n = 0; n < data->length; n++){
      text[n]=*(data->data+n);
    }
    text[n+1]='\0';

    rmstr_string(text,"file:///");

    linep=text;
    while( linep < text+strlen(text) && (EOF != (n = sscanf(linep, "%s\r\n", buf))) ){
      linep += strlen(buf)+2;      
      p=buf;
	  while ( NULL != (pp = strstr(p,"/")) && p < text+strlen(buf) ){
        *pp=G_DIR_SEPARATOR;
        p=pp+1;
	  };
      *(p-1)='\0';

	  strcpy(dir_path, buf);
      strcpy(filename, p);
      rmstr_string(filename,"\r\n");
      convert_to_urlencode(dir_path,FALSE);
      convert_to_urlencode(filename,FALSE);

      if ( (0 == strcasecmp(filename+strlen(filename)-4,".sf2"))
        || (0 == strcasecmp(filename+strlen(filename)-4,".cfg")) ){

        add_cr_buffers();

        dir_add(dir_path);
        sf2_add(filename);

        rm_cr_buffers();

      }
    }

    gtk_drag_finish(drag_context, TRUE, FALSE, time);
  } else {
    gtk_drag_finish(drag_context, FALSE, FALSE, time);
  }
gtk_text_buffer_set_modified (sf2_buffer, FALSE);
}


gboolean
on_textview3_drag_motion               (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_textview3_drag_data_received        (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{
  GdkDragAction actions;
  gchar text[MAX_LINE*40];
   actions=drag_context->actions;
  if ((actions & GDK_ACTION_COPY) && (data->length > 0) && (data->format == 8)) {
    gint n;
    gchar buf[MAX_LINE];
    gchar *p, *pp, *linep, dir_path[256], filename[256];

    if (data->length > MAX_LINE*40){
      gtk_drag_finish(drag_context, FALSE, FALSE, time);
      return;
    }

    for( n = 0; n < data->length; n++){
      text[n]=*(data->data+n);
    }
    text[n+1]='\0';

    rmstr_string(text,"file:///");

    linep=text;
    while( EOF != (n = sscanf(linep, "%s\r\n", buf)) ){
      linep += strlen(buf)+2;      
      p=buf;
	  while ( NULL != (pp = strstr(p,"/")) && p < text+strlen(buf) ){
        *pp=G_DIR_SEPARATOR;
        p=pp+1;
	  };
      *(p-1)='\0';

	  strcpy(dir_path, buf);
      strcpy(filename, p);
      rmstr_string(filename,"\r\n");
      convert_to_urlencode(dir_path,FALSE);
      convert_to_urlencode(filename,FALSE);

      if ( (0 == strcasecmp(filename+strlen(filename)-4,".sf2"))
        || (0 == strcasecmp(filename+strlen(filename)-4,".cfg")) ){
        add_cr_buffers();

        dir_add(dir_path);

        rm_cr_buffers();
      }
    }

    gtk_drag_finish(drag_context, TRUE, FALSE, time);
  } else {
    gtk_drag_finish(drag_context, FALSE, FALSE, time);
  }
}


gboolean
on_textview4_drag_motion               (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        guint            time,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_textview4_drag_data_received        (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{
  GdkDragAction actions;
  gchar text[MAX_LINE*40];
   actions=drag_context->actions;
  if ((actions & GDK_ACTION_COPY) && (data->length > 0) && (data->format == 8)) {
    gint n;
    gchar buf[MAX_LINE],buf2[MAX_LINE];
    gchar *p, *pp, *linep, dir_path[256], filename[256];

    if (data->length > MAX_LINE*40){
      gtk_drag_finish(drag_context, FALSE, FALSE, time);
      return;
    }

    for( n = 0; n < data->length; n++){
      text[n]=*(data->data+n);
    }
    text[n+1]='\0';

    rmstr_string(text,"file:///");

    linep=text;
    while( EOF != (n = sscanf(linep, "%s\r\n", buf)) ){
      linep += strlen(buf)+2;      
      p=buf;
	  while ( NULL != (pp = strstr(p,"/")) && p < text+strlen(buf) ){
        *pp=G_DIR_SEPARATOR;
        p=pp+1;
	  };
	  strcpy(buf2,buf);
      convert_to_urlencode(buf2,FALSE);
      convert_to_utf8(buf2,FALSE);
	  if (TRUE != is_dir(buf2))
        *(p-1)='\0';

	  strcpy(dir_path, buf);
      strcpy(filename, p);
      rmstr_string(filename,"\r\n");
      convert_to_urlencode(dir_path,FALSE);
      convert_to_urlencode(filename,FALSE);

      add_cr_buffers();

      dir_add(dir_path);

      rm_cr_buffers();
	}
    gtk_drag_finish(drag_context, TRUE, FALSE, time);
  } else {
    gtk_drag_finish(drag_context, FALSE, FALSE, time);
  }
}


void
on_about_win_destroy                   (GtkObject       *object,
                                        gpointer         user_data)
{
 gtk_widget_hide(about_win_dlg);
}


gboolean
on_about_win_delete_event              (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
 gtk_widget_hide(about_win_dlg);
  return TRUE;
}


void
on_out_winmm_btn_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (TRUE == gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(togglebutton)) ){
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_pa_win_btn), FALSE);
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_pa_directx_btn), FALSE);
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_pa_asio_btn), FALSE);

  out_device_c='d';
  deviceID=-1;
  set_device_list();
  set_deviceID(deviceID);
  update_cfg_buffer();
}

}

void
on_out_pa_win_btn_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (TRUE == gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(togglebutton)) ){
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_winmm_btn), FALSE);
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_pa_directx_btn), FALSE);
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_pa_asio_btn), FALSE);

out_device_c='p';
deviceID=-1;
set_device_list();
set_deviceID(deviceID);
update_cfg_buffer();
}

}


void
on_out_pa_directx_btn_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (TRUE == gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(togglebutton)) ){
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_winmm_btn), FALSE);
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_pa_win_btn), FALSE);
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_pa_asio_btn), FALSE);


out_device_c='P';
deviceID=-1;
set_device_list();
set_deviceID(deviceID);
update_cfg_buffer();
}

}


void
on_out_pa_asio_btn_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
if (TRUE == gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(togglebutton)) ){
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_winmm_btn), FALSE);
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_pa_win_btn), FALSE);
gtk_toggle_button_set_active    (GTK_TOGGLE_BUTTON(out_pa_directx_btn), FALSE);

out_device_c='o';
deviceID=-1;
set_device_list();
set_deviceID(deviceID);
update_cfg_buffer();
}

}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
gtk_widget_show(about_win_dlg);
}


void
on_help1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

char *locale;
gchar buf[256];
gchar *currentdir, *p, *pp;
strcpy(buf,"file:///");
currentdir=buf+8;
GetModuleFileName(NULL,currentdir,256-8);
p=currentdir+strlen(currentdir)-1;
while( p >= currentdir && *p != G_DIR_SEPARATOR ) p--;
if(p >=currentdir)  *p='\0';
p=currentdir;
while( (p < currentdir+strlen(currentdir)) && (NULL!=(pp=strstr(p,G_DIR_SEPARATOR_S))) ){
  *pp='/';
  p=++pp;
}
locale =setlocale(LC_ALL, NULL);
if( 0 == strcmp(locale,"Japanese_Japan.932")){
  strcat(buf,"/help/setwindrv_ja/setwindrv.htm");
}else{
  strcat(buf,"/help/setwindrv/setwindrv.htm");
}
  ShellExecute(NULL, NULL,buf, 
      NULL, NULL, SW_SHOWNORMAL);
}


void
on_entry1_realize                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
entry1=widget;
 gtk_entry_set_editable(GTK_ENTRY(entry1), FALSE);
}


void
on_textview4_realize                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
GtkTextTag *dir_hl_tag;

gtk_text_view_set_editable(GTK_TEXT_VIEW(widget),FALSE);
textview4=widget;
dir_buffer = gtk_text_buffer_new(dir_table);
//gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(dir_buffer), &dir_iter, 0);
//dir_cline=0;
gtk_text_view_set_buffer(GTK_TEXT_VIEW(textview4), GTK_TEXT_BUFFER(dir_buffer));
gtk_drag_dest_set(textview4,
		    GTK_DEST_DEFAULT_ALL,
		    drop_targets,
		    sizeof(drop_targets) / sizeof(drop_targets[0]),
		    GDK_ACTION_COPY);
dir_hl_tag = gtk_text_buffer_create_tag (dir_buffer, "highlight_tag", "background", "blue","foreground", "white", NULL);

}


void
on_textview2_realize                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
GtkTextTag *sf2_hl_tag;
textview2=widget;

//sf2_cline=0;
gtk_text_view_set_editable(GTK_TEXT_VIEW(widget),FALSE);
sf2_buffer = gtk_text_buffer_new(sf2_table);
//gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(sf2_buffer), &sf2_iter, 0);
gtk_text_view_set_buffer(GTK_TEXT_VIEW(textview2), GTK_TEXT_BUFFER(sf2_buffer));
gtk_drag_dest_set(textview2,
		    GTK_DEST_DEFAULT_ALL,
		    drop_targets,
		    sizeof(drop_targets) / sizeof(drop_targets[0]),
		    GDK_ACTION_COPY);  
sf2_hl_tag = gtk_text_buffer_create_tag (sf2_buffer, "highlight_tag", "background", "blue","foreground", "white", NULL);

}


void
on_textview3_realize                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
GtkTextTag *sf2_sel_hl_tag;

//sf2_sel_cline=0;
gtk_text_view_set_editable(GTK_TEXT_VIEW(widget),FALSE);
textview3=widget;
sf2_sel_buffer = gtk_text_buffer_new(sf2_sel_table);
//gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(sf2_sel_buffer), &sf2_sel_iter, 0);
gtk_text_view_set_buffer(GTK_TEXT_VIEW(textview3), GTK_TEXT_BUFFER(sf2_sel_buffer));
gtk_drag_dest_set(textview3,
		    GTK_DEST_DEFAULT_ALL,
		    drop_targets,
		    sizeof(drop_targets) / sizeof(drop_targets[0]),
		    GDK_ACTION_COPY);  
sf2_sel_hl_tag = gtk_text_buffer_create_tag (sf2_sel_buffer, "highlight_tag", "background", "blue","foreground", "white", NULL);
}


void
on_entry2_realize                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
entry2=widget;
}


void
on_output_device_lbl_realize             (GtkWidget       *widget,
                                        gpointer         user_data)
{
output_device_lbl=widget;
}


void
on_out_winmm_btn_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
out_winmm_btn=widget;
}


void
on_out_pa_win_btn_realize                (GtkWidget       *widget,
                                        gpointer         user_data)
{
out_pa_win_btn=widget;
}


void
on_out_pa_directx_btn_realize            (GtkWidget       *widget,
                                        gpointer         user_data)
{
out_pa_directx_btn=widget;
}


void
on_out_pa_asio_btn_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
out_pa_asio_btn=widget;
}


void
on_comboboxentry1_realize                (GtkWidget       *widget,
                                        gpointer         user_data)
{
comboboxentry1=widget;
}


void
on_textview5_realize        (GtkWidget       *widget,
                                        gpointer         user_data)
{

textview5=widget;
cfg_buffer = gtk_text_buffer_new(cfg_table);
//cfg_cline=0;
//gtk_text_buffer_get_iter_at_offset(GTK_TEXT_BUFFER(cfg_buffer), &cfg_iter, 0);

gtk_text_view_set_buffer(GTK_TEXT_VIEW(textview5), GTK_TEXT_BUFFER(cfg_buffer));
}

void
on_textview5_show                 (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_textview5_hide                      (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_windrv_setup_realize                (GtkWidget       *widget,
                                        gpointer         user_data)
{
  windrv_setup = widget;
  dir_select_dlg = create_dir_select_dlg ();
  cfg_edit_dlg = create_cfg_windows ();
  about_win_dlg = create_about_win_dlg ();
  cfg_open_dlg = create_cfg_open_dlg ();
  options_dlg = create_options_dlg ();
 
  other_buffer = gtk_text_buffer_new(other_table);
  other_syntax_buffer = gtk_text_buffer_new(other_syntax_table);
  comment_buffer = gtk_text_buffer_new(comment_table);
  extension_buffer = gtk_text_buffer_new(extension_table);
  
  gtk_widget_show(cfg_edit_dlg); //realize cfg_buffer
  gtk_widget_hide(cfg_edit_dlg);


}


void
on_windrv_setup_show                (GtkWidget       *widget,
                                        gpointer         user_data)
{
  get_open_browser();
  inifile_read();
  readconfig_buffer();
  set_device_list();
}


void
on_open1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_file_chooser_set_action(GTK_FILE_CHOOSER(cfg_open_dlg),GTK_FILE_CHOOSER_ACTION_SAVE);
  gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(cfg_open_dlg),"timidity.cfg");
  gtk_widget_show(cfg_open_dlg);
}


void
on_save1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget* dialog;
  gint resp;

  dialog = gtk_message_dialog_new(GTK_WINDOW(windrv_setup),
      GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,
      _("Really Overwrite Changes?"));
  resp = gtk_dialog_run (GTK_DIALOG (dialog));
  gtk_widget_destroy (dialog);
 
  if(GTK_RESPONSE_YES == resp) saveconfig_buffer();
}


void
on_quit1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget* dialog;
  gint resp;

  dialog = gtk_message_dialog_new(GTK_WINDOW(windrv_setup),
      GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,
      _("Save Changes?"));
  resp = gtk_dialog_run (GTK_DIALOG (dialog));
  gtk_widget_destroy (dialog);
 
  if(GTK_RESPONSE_YES == resp)   saveconfig_buffer();

  inifile_write();
  gtk_main_quit(); 
}


void
on_cfg_open_cancel_btn_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_hide(cfg_open_dlg);
}


void
on_cfg_open_open_btn_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{

  gchar *file_name;
  gchar *dir_name;
  gchar buf[FILENAME_MAX], buf2[FILENAME_MAX];

  gtk_widget_hide(cfg_open_dlg);
  file_name = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(cfg_open_dlg));
  dir_name = gtk_file_chooser_get_current_folder(GTK_FILE_CHOOSER (cfg_open_dlg));
  if( file_name != NULL){
    strncpy(buf,file_name,FILENAME_MAX-1);
    g_free(file_name);
  }else{
    GtkWidget* dialog;
    gint resp;
    dialog = gtk_message_dialog_new(GTK_WINDOW(windrv_setup),
      GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_QUESTION,GTK_BUTTONS_YES_NO,
      _("Create New timidity.cfg in %s ?"), dir_name );
    resp = gtk_dialog_run (GTK_DIALOG (dialog));
    gtk_widget_destroy (dialog);
    if(GTK_RESPONSE_YES == resp){
      
      if (dir_name != NULL){
        sprintf(buf, "%s%s%s",dir_name,G_DIR_SEPARATOR_S,"timidity.cfg");
        g_free(dir_name);
      }
    }
  }
  strncpy(buf2,buf,FILENAME_MAX-1);
  convert_to_utf8(buf2,FALSE);

  if(FALSE == set_cfg_path(buf2)){
    GtkWidget* dialog;
    dialog = gtk_message_dialog_new(GTK_WINDOW(windrv_setup),
      GTK_DIALOG_DESTROY_WITH_PARENT,GTK_MESSAGE_ERROR,GTK_BUTTONS_OK,
      _("timidity config file is not found:%s"),buf);
    gtk_dialog_run (GTK_DIALOG (dialog));
    gtk_widget_destroy (dialog);
    return;
  }

  strcpy(buf, get_cfg_path());
  convert_to_utf8(buf,TRUE);
  gtk_window_set_title(GTK_WINDOW(windrv_setup),buf);
  readconfig_buffer();
  set_device_list();
}

gboolean
on_textview2_key_release_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  int sf2_cline;
  GtkTextIter sl_iter, el_iter;

  if ( TRUE == gtk_text_buffer_get_selection_bounds(GTK_TEXT_BUFFER(sf2_sel_buffer), &sl_iter, &el_iter)){
  //  highlight_range_buffer(sf2_sel_buffer,&sl_iter, &el_iter);
  }else{
    highlight_cur_line_buffer(gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget)));
  }
  if ( TRUE == gtk_text_buffer_get_modified(GTK_TEXT_BUFFER(sf2_buffer)) ){
    update_cfg_buffer();
    gtk_text_buffer_set_modified(GTK_TEXT_BUFFER(sf2_buffer),FALSE);
  }
  return FALSE;
}


gboolean
on_textview4_key_release_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  int dir_cline;
   highlight_cur_line_buffer(gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget)));
   if ( TRUE == gtk_text_buffer_get_modified(GTK_TEXT_BUFFER(dir_buffer)) ){     
    update_cfg_buffer();
    gtk_text_buffer_set_modified(GTK_TEXT_BUFFER(dir_buffer),FALSE);
  }
  return FALSE;
}

gboolean
on_textview3_key_release_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  int sf2_sel_cline;
  GtkTextIter sl_iter, el_iter;

  if ( TRUE == gtk_text_buffer_get_selection_bounds(GTK_TEXT_BUFFER(sf2_sel_buffer), &sl_iter, &el_iter)){
  //  highlight_range_buffer(sf2_sel_buffer,&sl_iter, &el_iter);
  }else{
    highlight_cur_line_buffer(gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget)));
  }
}
void
on_cfg_open_dlg_destroy                (GtkObject       *object,
                                        gpointer         user_data)
{
gtk_widget_hide (cfg_open_dlg);
}


gboolean
on_cfg_open_dlg_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_widget_hide (cfg_open_dlg);
  return TRUE;
}


gboolean
on_textview5_key_release_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
gint line;
GtkTextBuffer *buffer;
/* if F1 pressed.  F1 value(press 65480 release 65470) */
if( event->keyval==65470){
  add_cr_buffers();
  buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget));      
  line=get_cur_line_buffer(buffer);
  show_syntax(buffer, line);
  rm_cr_buffers();
}
apply_config_buffer();
  return FALSE;
}

gboolean
on_textview5_button_press_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  gint x, y, buffer_x, buffer_y, line;
  GtkTextBuffer *buffer;
  GtkTextIter iter;



  switch( event->type ){
    case GDK_3BUTTON_PRESS:
    break;    
    case GDK_2BUTTON_PRESS:
      add_cr_buffers();
      gtk_widget_get_pointer(widget, &x, &y);
      gtk_text_view_window_to_buffer_coords(GTK_TEXT_VIEW(widget),
        GTK_TEXT_WINDOW_WIDGET,  x, y, &buffer_x, &buffer_y);
      gtk_text_view_get_iter_at_location(GTK_TEXT_VIEW(widget),&iter,buffer_x,buffer_y);
      line = gtk_text_iter_get_line(&iter);
      
      buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget));
      
      next_action(buffer, line);
      rm_cr_buffers();
    break;
    case GDK_BUTTON_PRESS:
    break;
  }     
  return FALSE;
}


void
on_cfg_editor_choose_selection_changed (GtkFileChooser  *filechooser,
                                        gpointer         user_data)
{
 gchar *filename;
 gchar buf[MAX_LINE];

 

 filename = gtk_file_chooser_get_filename(filechooser); 
 strncpy(buf,filename,MAX_LINE-1);
 gtk_file_chooser_unselect_filename(filechooser,filename);
 if ( (0 == strcasecmp( buf+strlen(buf)-4,".exe")) ||
      (0 == strcasecmp( buf+strlen(buf)-4,".bat")) ){
   gtk_entry_set_text(GTK_ENTRY(cfg_editor_ent),buf);
   convert_to_utf8(buf, FALSE);
   strcpy(cfg_editor_path_buf,buf);  
 }else{
   strcpy(cfg_editor_path_buf,cfg_editor_path);  
   gtk_entry_set_text(GTK_ENTRY(cfg_editor_ent),"");
 }
}


void
on_sf2_editor_choose_selection_changed (GtkFileChooser  *filechooser,
                                        gpointer         user_data)
{
 gchar *filename;
 gchar buf[MAX_LINE];

 filename = gtk_file_chooser_get_filename(filechooser); 
 strncpy(buf,filename,MAX_LINE-1);
 gtk_file_chooser_unselect_filename(filechooser,filename);
 if ( (0 == strcasecmp( buf+strlen(buf)-4,".exe")) ||
      (0 == strcasecmp( buf+strlen(buf)-4,".bat")) ){
   gtk_entry_set_text(GTK_ENTRY(sf2_editor_ent),buf);
   convert_to_utf8(buf, FALSE);
   strcpy(sf2_editor_path_buf,buf);  
 }else{
   strcpy(sf2_editor_path_buf,sf2_editor_path);  
   gtk_entry_set_text(GTK_ENTRY(sf2_editor_ent),"");
 }
}


void
on_prog_ok_btn_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  strncpy(cfg_editor_path, cfg_editor_path_buf,256-1);
  strncpy(sf2_editor_path, sf2_editor_path_buf,256-1);
  gtk_widget_hide(options_dlg);
}


void
on_prog_cancel_btn_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_hide(options_dlg);
}


void
on_options_dlg_destroy                 (GtkObject       *object,
                                        gpointer         user_data)
{
  gtk_widget_hide(options_dlg);
}


gboolean
on_options_dlg_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_widget_hide(options_dlg);
  return TRUE;
}


void
on_options1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ 
  strncpy(cfg_editor_path_buf,cfg_editor_path,256-1);
  strncpy(sf2_editor_path_buf,sf2_editor_path,256-1);
  gtk_widget_show(options_dlg);
}





void
on_windrv_setup_destroy                (GtkObject       *object,
                                        gpointer         user_data)
{
inifile_write();
gtk_main_quit(); 
}


gboolean
on_windrv_setup_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
inifile_write();
gtk_main_quit(); 
  return TRUE;
}


void
on_cfg_editor_ent_realize              (GtkWidget       *widget,
                                        gpointer         user_data)
{
cfg_editor_ent=widget;
}


void
on_sf2_editor_ent_realize              (GtkWidget       *widget,
                                        gpointer         user_data)
{
sf2_editor_ent=widget;
}

void
on_options_dlg_show                    (GtkWidget       *widget,
                                        gpointer         user_data)
{
char buf[256];

strncpy(buf,cfg_editor_path,256-1);
convert_to_utf8(buf,TRUE);
gtk_entry_set_text(GTK_ENTRY(cfg_editor_ent),buf);
strncpy(buf,sf2_editor_path,256-1);
convert_to_utf8(buf,TRUE);
gtk_entry_set_text(GTK_ENTRY(sf2_editor_ent),buf);
}


void
on_cfg_editor_choose_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_file_chooser_button_set_width_chars(GTK_FILE_CHOOSER_BUTTON(widget),0);
}


void
on_sf2_editor_choose_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_file_chooser_button_set_width_chars(GTK_FILE_CHOOSER_BUTTON(widget),0);
}

